// ShiftBuffer.java
// Raja Sooriamurthi

// a shift buffer is implemented simply as an object with
// a string member variable

public class ShiftBuffer 
{
  private String str = "";

  // *************************
  //   ShiftBuffer
  // *************************

  public ShiftBuffer (int size) 
  {
    for (int i = 0; i<size; i++) 
      str += "*";
  }
  
  // *************************
  //   shift
  // *************************

  public char shift (char x) 
  {
    char ret = str.charAt(0);
    str = (str+x).substring (1);
    return ret;
  }

  public String toString() 
  {
    return "[" + str + "]";
  }
  
  // *************************
  //   main
  // *************************

  public static void main (String[] args) 
  {
    ShiftBuffer sb = new ShiftBuffer (4);
    System.out.println (sb);
    for (int i = 'a' ; i <= 'h' ; i++)
      {
        sb.shift ((char) i);
        System.out.println (sb);
      }
  }
}

